' Necessary declarations to use DB-Lib...

' return values for all RETCODE type functions
Global Const SUCCEED% = 1
Global Const FAIL% = 0

' return values permitted in error handlers
Global Const INTEXIT% = 0
Global Const INTCONTINUE% = 1
Global Const INTCANCEL% = 2

Global Const MOREROWS = -1
Global Const NOMOREROWS = -2
Global Const REGROW = -1
Global Const BUFFULL = -3

' Status code for dbresults(). Possible return values are
' SUCCEED, FAIL, and NO_MORE_RESULTS.

Global Const NOMORERESULTS = 2

Declare Function SqlInit Lib "VBSQL.VBX" () As String
Declare Sub SQLWinExit Lib "VBSQL.VBX" ()
Declare Function SqlOpen Lib "VBSQL.VBX" (ByVal Login As Integer, Server As String) As Integer
Declare Sub SQLClose Lib "VBSQL.VBX" (ByVal SqlConn As Integer)
Declare Sub SqlFreeLogin Lib "VBSQL.VBX" (ByVal Login As Integer)
Declare Function SqlCmd Lib "VBSQL.VBX" (ByVal SqlConn As Integer, cmd As String) As Integer
Declare Function SqlExec Lib "VBSQL.VBX" (ByVal SqlConn As Integer) As Integer
Declare Function SqlResults Lib "VBSQL.VBX" (ByVal SqlConn As Integer) As Integer
Declare Function SqlNextRow Lib "VBSQL.VBX" (ByVal SqlConn As Integer) As Integer
Declare Function SqlSendCmd Lib "VBSQL.VBX" (ByVal SqlConn As Integer, cmd As String) As Integer
Declare Function SqlOpenConnection Lib "VBSQL.VBX" (Server As String, LoginID As String, Pwd As String, WorkStation As String, Application As String) As Integer
Declare Function SqlOpenConnection Lib "VBSQL.VBX" (Server As String, LoginID As String, Pwd As String, WorkStation As String, Application As String) As Integer
Declare Function SqlUse Lib "VBSQL.VBX" (ByVal SqlConn As Integer, database As String) As Integer
Declare Sub SqlExit Lib "VBSQL.VBX" ()
Declare Function SqlColLen Lib "VBSQL.VBX" (ByVal SqlConn As Integer, ByVal Column As Integer) As Integer
Declare Function SqlDatLen Lib "VBSQL.VBX" (ByVal SqlConn As Integer, ByVal Column As Integer) As Long
Declare Function SqlData Lib "VBSQL.VBX" (ByVal SqlConn As Integer, ByVal Column As Integer) As String
Declare Function SqlDataReady Lib "VBSQL.VBX" (ByVal SqlConn As Integer) As Integer
Declare Function SqlNumCols Lib "VBSQL.VBX" (ByVal SqlConn As Integer) As Integer

