' ODBC Declarations and Global Constants
Global Const SQL_SUCCESS = 0
Global Const SQL_SUCCESS_WITH_INFO = 1
Global Const SQL_ERROR = -1
Global Const SQL_CLOSE = 0
Global Const SQL_DRIVER_NOPROMPT = 0
Global Const SQL_DRIVER_COMPLETE = 1
Global Const SQL_DRIVER_PROMPT = 2
Global Const SQL_DRIVER_COMPLETE_REQUIRED = 3
Global Const SQL_ASYNC_ENABLE = 4
Global Const SQL_STILL_EXECUTING =2

' API Declarations
Declare Function SQLAllocEnv Lib "odbc.dll" (env As Long) As Integer
Declare Function SQLFreeEnv Lib "odbc.dll" (ByVal env As Long) As Integer

Declare Function SQLAllocConnect Lib "odbc.dll" (ByVal env As Long, hdbc As Long) As Integer
Declare Function SQLConnect Lib "odbc.dll" (ByVal hdbc As Long, ByVal Server As String, ByVal serverlen As Integer, ByVal uid As String, ByVal uidlen As Integer, ByVal pwd As String, ByVal pwdlen As Integer) As Integer
Declare Function SQLDriverConnect Lib "odbc.dll" (ByVal hdbc As Long, ByVal hWnd As Integer, ByVal szCSIn As String, ByVal cbCSIn As Integer, ByVal szCSOut As String, ByVal cbCSMax As Integer, cbCSOut As Integer, ByVal f As Integer) As Integer

Declare Function SQLFreeConnect Lib "odbc.dll" (ByVal hdbc As Long) As Integer
Declare Function SQLDisconnect Lib "odbc.dll" (ByVal hdbc As Long) As Integer
Declare Function SQLAllocStmt Lib "odbc.dll" (ByVal hdbc As Long, hstmt As Long) As Integer
Declare Function SQLFreeStmt Lib "odbc.dll" (ByVal hstmt As Long, ByVal EndOption As Integer) As Integer
Declare Function SQLTables Lib "odbc.dll" (ByVal hstmt As Long, ByVal q As Long, ByVal cbq As Integer, ByVal o As Long, ByVal cbo As Integer, ByVal t As Long, ByVal cbt As Integer, ByVal tt As Long, ByVal cbtt As Integer) As Integer
Declare Function SQLGetInfo Lib "odbc.dll" (ByVal hdbc As Long, ByVal hWnd As Integer, ByVal szInfo As String, ByVal cbInfoMax As Integer, cbInfoOut As Integer) As Integer
Declare Function SQLGetInfoNum Lib "odbc.dll" Alias "SQLGetInfo" (ByVal hdbc As Long, ByVal hWnd As Integer, szInfo As Long, ByVal cbInfoMax As Integer, cbInfoOut As Integer) As Integer

Declare Function SQLExecDirect Lib "odbc.dll" (ByVal hstmt As Long, ByVal sqlString As String, ByVal sqlstrlen As Long) As Integer
Declare Function SQLNumResultCols Lib "odbc.dll" (ByVal hstmt As Long, NumCols As Integer) As Integer
Declare Function SQLDescribeCol Lib "odbc.dll" (ByVal hstmt As Long, ByVal colnum As Integer, ByVal colname As String, ByVal Buflen As Integer, colnamelen As Integer, dtype As Integer, dl As Long, ds As Integer, n As Integer) As Integer
Declare Function SQLFetch Lib "odbc.dll" (ByVal hstmt As Long) As Integer
Declare Function SQLGetData Lib "odbc.dll" (ByVal hstmt As Long, ByVal col As Integer, ByVal wConvType As Integer, ByVal lpbBuf As String, ByVal dwbuflen As Long, lpcbout As Long) As Integer
Declare Function SQLError Lib "odbc.dll" (ByVal env As Long, ByVal hdbc As Long, ByVal hstmt As Long, ByVal SQLState As String, NativeError As Long, ByVal Buffer As String, ByVal Buflen As Integer, Outlen As Integer) As Integer
Declare Function SQLSetStmtOption Lib "odbc.dll" (ByVal hstmt As Long, ByVal fOption As Integer, ByVal vParam As Long) As Integer

